<template>
<div>
      <GoBack />
  <li class="d-flex align-items-center list-group-item">
    <span
      class="flex-grow-1 text-center shadow-none"
      :class="{ completed }"
      @click="$emit('on-toggle')"
      v-if="!isEditing"
    >
      <span>{{ todo.name }}</span>
    </span>
    <form v-else class="flex-grow-1" @submit.prevent="finishEditing()">
      <input
        type="text"
        class="form-control"
        v-model="newName"
        @blur="finishEditing()"
        ref="newTodo"
      />
    </form>
    <button
      @click="startEditing()"
      class="btn btn-outline-primary border-0 ml-2"
    >
      <span class="fa fa-edit"></span>
    </button>
    <button @click="deleteTodo(todo)" class="btn btn-outline-danger border-0">
      <span class="fa fa-trash"></span>
    </button>
  </li>
  </div>
</template>
<script>
import store from "@/store.js";
import GoBack from "@/components/GoBack";

export default {
  components: {
    GoBack
  },
  data() {
    return {
      isEditing: false,
      todo: fetch("http://localhost:5000/lists/"+this.idList+"/todo/"+this.id+"", {"Content-Type": "application/json"} )
        .then(response => response.json())
        .then(res => this.todo = res)
    };
  },
  props: {
    id: Number,
    idList: Number,
    completed: Boolean
  },
  methods: {
    startEditing() {
      if (this.isEditing) {
        this.finishEditing();
      } else {
        this.newName = this.name;
        this.isEditing = true;
        this.$nextTick(() => this.$refs.newTodo.focus());
      }
    },
    finishEditing() {
      this.isEditing = false;
      this.todo.name = this.newName;
    },
    deleteTodo(deletedTodo) {
      store.todos[this.idList-1].tasks_list.splice(deletedTodo.id-1,1)
      this.$router.push({name:'TodoList', param: {idList: this.idList}});
    }
  }
};
</script>

<style scoped>
img {
  max-width: 600px;
  height: auto;
  width: 100%;
  max-height: 400px;
}
.experience-details {
  display: flex;
  justify-content: space-between;
  padding: 40px 0;
}
p {
  margin: 0 40px;
  font-size: 20px;
  text-align: left;
}
</style>
